package xyz.lychee.lagfixer.hooks;

import me.lokka30.levelledmobs.LevelledMobs;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import xyz.lychee.lagfixer.LagFixer;
import xyz.lychee.lagfixer.managers.HookManager;
import xyz.lychee.lagfixer.objects.AbstractHook;

public class LevelledMobsHook extends AbstractHook {
   private static LevelledMobsHook instance;
   private MobsImplementation levelledMobs;

   public LevelledMobsHook(LagFixer plugin, HookManager manager) {
      super(plugin, manager);
      instance = this;
   }

   public void load() {
      this.levelledMobs = new MobsImplementation();
   }

   public void disable() {
   }

   public String plugin() {
      return "LevelledMobs";
   }

   public MobsImplementation getLevelledMobs() {
      return this.levelledMobs;
   }

   public static LevelledMobsHook getInstance() {
      return instance;
   }

   public static class MobsImplementation {
      private final LevelledMobs mobs = LevelledMobs.getInstance();

      public boolean isLevelled(Entity e) {
         return e instanceof LivingEntity && this.mobs.levelManager.isLevelled((LivingEntity)e);
      }
   }
}
